//---------------------------------------------------------------------------
#ifndef TelebotH
#define TelebotH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ScktComp.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TTelebotForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar;
        TMemo *Memo;
        TLabel *Label1;
        TButton *ExitButton;
        TButton *ConnectButton;
        TButton *SendButton;
        TClientSocket *ClientSocket;
        TBitBtn *ForwardBtn;
        TBitBtn *BackBtn;
        TBitBtn *RightBtn;
        TBitBtn *LeftBtn;
        TTrackBar *FwdSpeed;
        TTrackBar *TurnSpeed;
        TTrackBar *BackSpeed;
        TRadioGroup *RadioGroup1;
        TRadioButton *OLmodeButton;
        TRadioButton *PVmodeButton;
        TRadioButton *IVmodeButton;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TLabel *Label7;
        void __fastcall ConnectButtonClick(TObject *Sender);
        void __fastcall SendButtonClick(TObject *Sender);
        void __fastcall ClientSocketConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientSocketDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientSocketError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
        void __fastcall ClientSocketRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ExitButtonClick(TObject *Sender);
        void __fastcall ForwardBtnMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ForwardBtnMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall BackBtnMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall BackBtnMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall LeftBtnMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall LeftBtnMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall RightBtnMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall RightBtnMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall FormKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall OLmodeButtonClick(TObject *Sender);
        void __fastcall PVmodeButtonClick(TObject *Sender);
        void __fastcall IVmodeButtonClick(TObject *Sender);
private:	// User declarations
        AnsiString Server;              // string for server IP address
        bool bConnected;                // connect status

        void SendAllStop(void);
        void SendMotors(int leftSpeed, int rightSpeed);
        void SendForward(void);
        void SendBack(void);
        void SendLeftTurn(void);
        void SendRightTurn(void);

public:		// User declarations
        __fastcall TTelebotForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TTelebotForm *TelebotForm;
//---------------------------------------------------------------------------
#endif
